﻿ /**
* fd_videoPlayer by Francis Gómez and Sergio Daroca
* Easy videoPlayer for flashDance CMS
* Allows easy skinning with automatic video controls layout according to video size
* Can mask video for rounded corners, and set videoControls to auto fade on video rollOut
* TODO
* -use notifications for events
* -allow runtime skinning through external icons (pngs)
* [-do modal / fullscreen versions
* [-add ff rr stop volume controls
* -allow calling the videoPlayer from actionscript new fd_videoPlayer();
* -do getters and setters for main properties (vControls auto fade, masking, skin selection, looping, volume, autostart, controlSet, videoURL / videoPlaylist)
* -and then add instance parameter (object with those props)
* -do status prop
* -add skafolding for external settings - config
* [-add playList builtIn support (no...)
* -CMS configuration: -skin and other props selections -URL/PlayList -DragandDrop and configFile Selector on page Editor...
* @usage
* @return
*/
import tv.zarate.Utils.Trace;
import org.asapframework.events.notificationcenter. *;
//import tweens.zigo.TweenShortcuts //to fade in out controls (also for rollOvers?)
import delegate;
//import flash.geom.Rectangle;
class fd_videoPlayer extends MovieClip
{
	//Streams
	private var videoConexion : NetConnection;
	private var videoStream : NetStream;
	private var audio : Sound;
	private var audio_mc : MovieClip;
	//Mcs
	private var parentTimeline : MovieClip;
	private var videoPlayer : MovieClip;
	private var videoHolder : MovieClip;
	private var vControls : MovieClip;
	private var videoMaskMc : MovieClip;
	private var modalMC : MovieClip;
	//Properties
	private var videoConnectionReady: Boolean=false;
	private var wparams;
	private var videoPos : Number;
	private var duracion : Number;
	private var ancho : Number;
	private var alto : Number;
	private var factor : Number;
	private var duracionVid : Number;
	private var vControls_original_Positions : Array;
	private var appPulseInterval : Number;
	private var pulseActions : Object;
	private var skinIsReady : Boolean = false;
	private var _status = 'hidden';	
	private var avance : Boolean = false;
	private var retroceso : Boolean = false;
	private var mute : Boolean = false;
	private var isModal : Boolean = false;
	public var videoName : String;
	//OPTIONS
	public var videoURL : String=undefined;
	public var _maskVideo : Boolean = false;
	public var videoMaskRad : Number = 10;
	public var fadevControls : Boolean = true;
	public var loop : Boolean = false;
	public var skinName : String = 'default_fd_videoPlayer_skin';
	public var startVolume : Number = 50;
	public var autoStart= 'true';
	public var setModal='true';
	public var modalColor=0x000000;
	public var modalAlpha=80;
	public function fd_videoPlayer (pName, pTimeline, pParams)
	{
		//create fd_videoPlayer MC
		videoPlayer = makeMC (pTimeline, pName);
		//Trace.trc('pTimeline: ' + pTimeline._name+' '+pTimeline._x);
		//Trace.trc('videoPlayer: ' + videoPlayer+' '+videoPlayer._x);
		//trace('pTimeline: ' + pTimeline._name+' '+pTimeline._x);
		//trace('videoPlayer: ' + videoPlayer+' '+videoPlayer._x);		
		//move videoPlayer to Stage 0,0:
		var Xoffset= Stage.width/2-780/2;
		var Yoffset= 0;
		videoPlayer._x=-Xoffset;
		videoPlayer._y=-Yoffset;
		//create default video object
		videoHolder = videoPlayer.attachMovie ('videoHolder', 'videoHolder', videoPlayer.getNextHighestDepth ());
		//init actionPulse
		pulseActions = new Object ();
		//if (pParams != undefined && pParams != null)
		wparams = pParams;
		setParams ();
		NotificationCenter.getDefaultCenter ().addObserver (this,
		"onPleasePlayVideoNote",
		"pleasePlayVideoNotification");
	}
	public function set status (pStatus)
	{
		switch (pStatus)
		{
			case 'active' :
			setActiveStatus ();
			break;
			case 'hidden' :
			default :
			setHiddenStatus ();
			break;
		}
		_status = pStatus;
	}
	public function get status ()
	{
		return _status;
	}
	private function setParams ()
	{
		for (var wprop in wparams)
		{
			if (wparams [wprop] != undefined)
			{
				this [wprop] = wparams [wprop];
			}
		}
		if (videoURL.length > 0)
		{
			status = 'enabled';
		} else 
		{
			status = _status;
		}
		create_fd_videoPlayer ();
	}
	private function setHiddenStatus ()
	{
		delete appPulseInterval;
		pulseActions= new Object();
		videoPlayer._visible = false;
	}
	private function setActiveStatus ()
	{
		videoPlayer._visible = true;
		//setModalScreen();
	}
	private function onSkinReady ()
	{
		//removeAppPulseAction ('chekIfSkinIsReady');
		//This once the skin is ready
		//vControls.sonido_btn.noaudio._visible = false;
		//trace('SKIN IS READY _maskVideo: ' + _maskVideo)
		if (_maskVideo)
		{
			maskVideo (true);
		} else
		{
			maskVideo (false);
		}
		if (fadevControls)
		{
			setFadevControls ();
		}
		//get original play, pause, mute and progressBar (all mcs, actually) _x & _y as percentages of bkg _W & _H
		vControls.bkg._xscale = vControls.bkg._yscale = 100;
		var oW = vControls.bkg._width;
		var oH = vControls.bkg._height;
		vControls_original_Positions = new Array ();
		//var tmpMCs=new Array();
		for (var xMC in vControls)
		{
			var tmpMC = vControls [xMC];
			//trace('typeof(tmpMC): ' + typeof(tmpMC))
			if (typeof (tmpMC) == "movieclip")
			{
				var tmpPos = new Object ();
				tmpPos.xpc = tmpMC._x / oW;
				//tmpPos.ypc=tmpMC._x/oH;
				tmpPos.mc = tmpMC;
				//trace('tmpMC: ' + tmpMC._name + ', tmpMC._x: ' + tmpMC._x)
				vControls_original_Positions.push (tmpPos);
			}
		}
		//set default enabled and disabled controls
		enableControl ('mute_btn');
		disableControl ('unmute_btn');
		enableControl ('pause_btn');
		disableControl ('play_btn');
		if(videoConnectionReady==false){
			createVideoConnection ();
		}
		creaControles ();
		//appPulseInterval = setInterval (this, "appPulse", 300);
		//then if videoURL not null call cargar video
		//else set hidden and ready
		if (videoURL != undefined)
		{
			playNewVideo (videoURL);
		}
	}
	private function create_fd_videoPlayer ()
	{
		//trace('create_fd_videoPlayer CALLED: ' + create_fd_videoPlayer)
		appPulseInterval = setInterval (this, "appPulse", 300);
		//addAppPulseAction ('chekIfSkinIsReady')
		// LEFT OUT til skin is ready by now: create netStreams and start defaults and apply options
		//grab skin assets and build skin
		buildSkin ();
		//
		//then if videoURL not null call cargar video
		//else set hidden and ready
		
	}
	private function chekIfSkinIsReady ()
	{
		//trace('skinIsReady: ' + skinIsReady)
		if (skinIsReady)
		{
			//trace('skinIsReady: ' + skinIsReady)
			removeAppPulseAction ('chekIfSkinIsReady');
			onSkinReady ();
		}
	}
	private function buildSkin ()
	{
		//attach from library default skin if there is no skin dir other than default value
		//but, then we DO need a library... and I dont like that much...
		vControls.removeMovieClip ();
		if (skinName == 'default_fd_videoPlayer_skin')
		{
			//trace('USING default library skin: ' + skinName)
			vControls = videoPlayer.attachMovie ('default_fd_videoPlayer_skin', 'vControls', videoPlayer.getNextHighestDepth ());
			//trace('vControls: ' + vControls)
			//removeAppPulseAction ('chekIfSkinIsReady');
			
		} else 
		{
			vControls = videoPlayer.attachMovie (skinName, 'vControls', videoPlayer.getNextHighestDepth ());
		}
		//doResizeVideo (ancho, alto);
		skinIsReady = true;
		onSkinReady ();
	}
	public function playNewVideo (path : String,pvideoName: String)
	{
		if(arguments.length==2){
			videoName= arguments[2];
		} else {
			videoName=path.slice(0,-4);
		}
		videoURL = path;
		//videoStream.close();
		//creaControles();
		//createVideoConnection ();
		enableControl ('mute_btn');
		disableControl ('unmute_btn');
		//autoplay is supposed
		disableControl ('play_btn');
		enableControl ('pause_btn');
		if(_status!='active'){
			status='active';
		}
		if (isModal != true && setModal!='false')
		{
			setModalScreen ();
		} //else 
		//{
			reproduceVideo ()
		//}
	}
	private function setModalScreen()
	{
		if(isModal){
			return false;
		} 
		drawModalScreen();
		//enableModalScreen();
		modalMC._visible=true;
		isModal=true;
		//reproduceVideo ();
	}
	private function createVideoConnection () : Void
	{
		/*if(videoConexion==undefined){
		
		//trace('videoConexion: ' + videoConexion)
		}
		if(videoStream!=undefined){
		videoStream.close();
		//trace('videoStream.close: ' + videoStream.close)
		}*/
		//videoConexion=null;
		videoConexion = new NetConnection ();
		videoConexion.connect (null);
		videoStream = new NetStream (videoConexion);
		/*videoStream.onStatus = function(infoObject:Object):Void {
		
		//trace("status (" + this.time + " seconds)\n");
		//trace("\t Level: " + infoObject.level + "\n");
		//trace("\t Code: " + infoObject.code + "\n\n");
		
		};*/
		var resizeVideoDelegate = delegate.create (this, doResizeVideo);
		videoStream.onMetaData = function (Meta)
		{
			duracion = Meta.duration;
			ancho = Meta.width;
			alto = Meta.height;
			//trace ('META DATA llegó: ' + duracion)
			resizeVideoDelegate (ancho, alto);
		};
		//videoHolder.video.clear();
		videoHolder.video.attachVideo (videoStream);
		audio_mc.attachAudio (videoStream);
		audio = new Sound (audio_mc);
		audio.setVolume (50);
		videoStream.setBufferTime (5);
		//reproduceVideo();
		videoConnectionReady=true;
	}
	private function reproduceVideo ()
	{
		doResizeVideo (ancho, alto);
		disableControl ('play_btn');
		enableControl ('pause_btn');
		//TODO unmute if we are starting? is necessary?
		videoStream.play (videoURL);
		initProgressBar ();
	}
	private function doResizeVideo (_w, _h)
	{
		var Xoffset= Stage.width/2-780/2;
		var Yoffset= 0;
		videoPlayer._x=-Xoffset;
		videoPlayer._y=-Yoffset;
		videoPlayer.vControls._visible=false;
		//set new video size
		videoHolder.video._width = _w;
		videoHolder.video._height = _h;
		//set mask size
		videoMaskMc._width = _w;
		videoMaskMc._height = _h;
		videoMaskMc._x = videoHolder._x;
		videoMaskMc._y = videoHolder._y;
		//get original size of bkg to set progressBarr target _W
		vControls.bkg._xscale = vControls.bkg._yscale = 100;
		var oW = vControls.bkg._width;
		//var oH=vControls.bkg._height;
		//set original proggressBar _x_y_scales to find new target _w
		vControls.progressBar._xscale = vControls.progressBar._yscale = 100;
		var factorbarra = vControls.progressBar._width / oW;
		var newProgressBarWidth = _w * factorbarra;
		vControls.progressBar._width = _w * factorbarra;
		//position vControls below video and extend _width of bkg
		vControls._y = videoHolder.video._height;
		vControls.bkg._width = _w;
		//Position all vControls MCs in their new position by percentage...
		var mcl = vControls_original_Positions.length;
		var tW = _w;
		//var tH = vControls.bkg._height;
		for (var it = 0; it < mcl; it ++)
		{
			var ntmpmc = vControls_original_Positions [it];
			ntmpmc.mc._x = ntmpmc.xpc * tW;
			//trace (ntmpmc.mc._name + '._x: ' + ntmpmc.mc._x)
			//ntmpmc.mc._y=ntmpmc.ypc*tH;
		}
		if(isModal){
			//centerVideo();
			videoHolder._x=Math.floor(Stage.width/2-videoHolder._width/2);
			videoHolder._y=Math.floor(Stage.height/2-videoHolder._height/2);
			vControls._y = videoHolder._y+videoHolder.video._height;
			vControls._x = videoHolder._x;
			modalMC._width=Stage.width;
			modalMC._height=Stage.height;
			//drawModalScreen();
		}
		videoMaskMc._x = videoHolder._x;
		videoMaskMc._y = videoHolder._y;
		videoPlayer.vControls._visible=true;
		//if we wanted to mantain vControls.bkg proportions, uncomment next line
		//vControls.bkg._yscale=vControls.bkg._xscale;
		
	}
	private function creaControles () : Void
	{
		vControls.play_btn.onRelease = delegate.create (this, _play);
		vControls.pause_btn.onRelease = delegate.create (this, _pause);
		vControls.stop_btn.onRelease = delegate.create (this, _stop);
		vControls.avance_btn.onPress = vControls.avance_btn.onRelease = vControls.avance_btn.onReleaseOutside = delegate.create (this, _avance);
		vControls.retro_btn.onPress = vControls.retro_btn.onRelease = vControls.retro_btn.onReleaseOutside = delegate.create (this, _retro);
		vControls.mute_btn.onRelease = delegate.create (this, _mute);
		vControls.unmute_btn.onRelease = delegate.create (this, _mute);
		vControls.exit_btn.onRelease = delegate.create (this, _exit);
	}
	private function appPulse ()
	{
		//var appPl=pulseActions.length;
		for (var xAction in pulseActions)
		{
			var tmpAction = pulseActions [xAction];
			//trace('tmpAction: ' + xAction+' '+tmpAction+'>>>')
			this [xAction]();
			//this[pulseActions[xAction]]();
		}
	}
	private function addAppPulseAction (newPulseAction)
	{
		//pulseActions[newPulseAction]=this[newPulseAction];
		pulseActions [newPulseAction] = new Object ();
		//trace('pulseActions: ' + pulseActions)
		for (var xAction in pulseActions)
		{
			var tmpAction = pulseActions [xAction];
			//trace ('pulseActions are: ' + xAction + '>>>')
			//this[xAction]();
			//this[pulseActions[xAction]]();
		}
		//trace ('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')
		
	}
	private function removeAppPulseAction (removedPulseAction)
	{
		pulseActions [removedPulseAction] = null;
	}
	private function setFadevControls () : Void
	{
		vControls._alpha = 0;
		addAppPulseAction ('checkvControlsAutoFade');
	}
	private function checkvControlsAutoFade ()
	{
		var xm = videoHolder._xmouse;
		//trace('xm: ' +xm);
		var ym = videoHolder._ymouse;
		//var minX=videoHolder._x;
		//var minY=videoHolder._y;
		var minX=0;
		var minY=0;
		var maxY = videoHolder._height+vControls._height;
		var maxX = videoHolder._width;
		if (xm >= minX && xm <= maxX && ym >= minY && ym <= maxY)
		{
			fadevControlsIn ();
		} else
		{
			fadevControlsOut ();
		}
	}
	private function fadevControlsIn ()
	{
		if (vControls._alpha != 100)
		{
			vControls._alpha = 100;
		}
	}
	private function fadevControlsOut ()
	{
		if (vControls._alpha != 0)
		{
			vControls._alpha = 0;
		}
	}
	public function maskVideo (bool)
	{
		if (bool)
		{
			if (videoMaskMc == undefined)
			{
				videoMaskMc = drawVideoMask ();
			}
			videoHolder.setMask (videoMaskMc);
		} else
		{
			videoHolder.setMask (null);
			videoMaskMc._visible = false;
		}
		videoMaskMc._visible = false;
	}
	private function _mute ()
	{
		if (mute)
		{
			audio.setVolume (50);
			enableControl ('mute_btn');
			disableControl ('unmute_btn');
		} else
		{
			audio.setVolume (0);
			enableControl ('unmute_btn');
			disableControl ('mute_btn');
		}
		//vControls.sonido_btn.noaudio._visible = !vControls.sonido_btn.noaudio._visible;
		mute = ! mute;
	}
	private function _play ()
	{
		videoStream.pause (false);
		enableControl ('pause_btn');
		disableControl ('play_btn');
		if (pulseActions ['updateProgressBar'] == null)
		{
			initProgressBar ();
		}
	};
	private function _pause ()
	{
		videoStream.pause (true);
		enableControl ('play_btn');
		disableControl ('pause_btn');
	};
	private function _stop ()
	{
		//videoStream.close()
		videoStream.pause (true);
		videoStream.seek (0);
		enableControl ('play_btn');
		disableControl ('pause_btn');
	};
	private function _avance ()
	{
		if ( ! avance)
		{
			//intervalo_avance = setInterval (this, "ff", 500);
			addAppPulseAction ('ff');
		} else
		{
			removeAppPulseAction ('ff');
			//clearInterval (intervalo_avance);
			//intervalo_avance = null;
			
		}
		avance = ! avance;
	};
	private function _exit()
	{
		//stop the video and erase videoFrame
		//set disabled/hidden status
		_stop ();
		status='hidden';
	}
	private function ff ()
	{
		if ((videoStream.time + 1) < videoStream.duracion)
		{
			videoPos = videoStream.time + 1;
			videoStream.seek (Math.floor (videoPos));
		} else
		{
			avance = false;
			removeAppPulseAction ('ff');
			//clearInterval (intervalo_avance);
			//intervalo_avance = null;
			
		}
	}
	private function _retro ()
	{
		if ( ! retroceso)
		{
			addAppPulseAction ('rw');
			//intervalo_avance = setInterval (this, "rw", 500);
			
		} else
		{
			removeAppPulseAction ('rw');
			//clearInterval (intervalo_avance);
			//intervalo_avance = null;
			
		}
		retroceso = ! retroceso;
	};
	private function rw ()
	{
		if ((videoStream.time - 1) > 0)
		{
			videoPos = videoStream.time - 1;
			videoStream.seek (Math.floor (videoPos));
		} else
		{
			removeAppPulseAction ('rw');
			//clearInterval (intervalo_avance);
			//intervalo_avance = null;
			retroceso = false;
		}
	}
	private function initProgressBar ()
	{
		factor = vControls.progressBar.linea_base._width / 100;
		//factor = progressBar._width/100;
		//intervalo_progreso = setInterval (this, "updateProgressBar", 300);
		addAppPulseAction ('updateProgressBar');
	}
	private function updateProgressBar ()
	{
		temporizador (videoStream.time);
		var porciento_video : Number = Math.round (videoStream.time / videoStream.duracion * 100);
		textoInfoReproduccion (videoStream.time + " / " + videoStream.duracion);
		vControls.progressBar.linea_tiempo._width = Math.floor (factor * porciento_video);
		var porciento_carga : Number = Math.round (videoStream.bytesLoaded / videoStream.bytesTotal * 100);
		//trace('porciento_carga: ' + porciento_carga)
		vControls.progressBar.linea_carga._width = factor * porciento_carga;
		//trace( vControls.progressBar.linea_carga._width)
		/*
		textoInfoCarga(Math.round(videoStream.bytesLoaded / 1000) + " de " + Math.round(videoStream.bytesTotal / 1000) + " KB cargados (" + porciento_carga + "%)");
		}else{
		textoInfoCarga("");
		}
		*/
		if (porciento_video >= 100)
		{
			removeAppPulseAction ('updateProgressBar');
			//clearInterval (intervalo_progreso);
			//intervalo_progreso = null;
			_stop ();
		}
	}
	private function textoInfoReproduccion (_cadena)
	{
		vControls.proceso_tiempo.text = _cadena;
	}
	private function textoInfoCarga (_cadena)
	{
		vControls.proceso_carga_txt.text = _cadena;
	}
	private function temporizador (_seg : Number)
	{
		var min : String = String (Math.floor (_seg / 60));
		if (parseInt (min) < 10) min = "0" + min;
		var seg : String = String (Math.floor (_seg % 60));
		if (parseInt (seg) < 10) seg = "0" + seg;
		var mili : String = String (((_seg % 60) - Math.floor (_seg % 60)) * 1000).substr (0, 2);
		//trace("MIN: "+min+", seg: "+seg+", mili: "+mili);
		vControls.tiempo_mc.min_txt.text = min;
		vControls.tiempo_mc.seg_txt.text = seg;
		vControls.tiempo_mc.mili_txt.text = mili;
	}
	//TODO use tweener class to fade in out controls (also for rollOvers?)
	private function disableControl (cname)
	{
		vControls [cname]._visible = false;
	}
	private function enableControl (cname)
	{
		vControls [cname]._visible = true;
	}
	// NOTIFICATIONS IN
	private function onPleasePlayVideoNote (inNote : Notification)
	{
		var pNote=inNote.data;
		for(var i in pNote) //trace('key: ' + i + ', value: ' + pNote[i]);
		var pvideoName=pNote.videoName;
		var pvideoURL=pNote.videoURL;
		//trace('pvideoURL: ' + pvideoURL)
		playNewVideo (pvideoURL,pvideoName);
	}
	//NOTIFICATIONS OUT
	function notify_videoStarted ()
	{
		var videoObject = new Object ();
		videoObject.videoName = videoName;
		videoObject.videoURL = videoURL;
		NotificationCenter.getDefaultCenter ().post ("videoStartedNotification",
		null,
		videoObject);
	}	
	//UTILS
	private function drawVideoMask (w, h, rad, x, y, stroke, fill)
	{
		w = videoHolder.video._width ;
		h = videoHolder.video._height ;
		//w=100;
		//h=100;
		rad = videoMaskRad;
		//x=0;
		//y=0;
		var stroke = {
			width : 0, color : 0x808080, alpha : 0
		};
		var fill = {
			color : 0xcccccc, alpha : 100
		};
		var maskMC = makeMC (videoPlayer, 'videoMask');
		maskMC.lineStyle (stroke.width, stroke.color, stroke.alpha);
		maskMC.beginFill (fill.color, fill.alpha);
		maskMC.moveTo (0 + rad, 0);
		maskMC.lineTo (w - rad, 0);
		maskMC.curveTo (w, 0, w, rad);
		maskMC.lineTo (w, h - rad);
		maskMC.curveTo (w, h, w - rad, h);
		maskMC.lineTo (0 + rad, h);
		maskMC.curveTo (0, h, 0, h - rad);
		maskMC.lineTo (0, 0 + rad);
		maskMC.curveTo (0, 0, 0 + rad, 0);
		maskMC.endFill ();
		//maskMC._x = x;
		//maskMC._y = y;
		maskMC._x = videoHolder._x;
		maskMC._y = videoHolder._y;
		return maskMC;
	}
	private function drawModalScreen()
	{
		//if (modalMC==undefined)
		//{
			modalMC=makeMC(videoPlayer,'modalScreen');
		//}
		modalMC.swapDepths(findLowestDepth(videoPlayer));
		var sW=Stage.width;
		var sH=Stage.height;
		//modalMC.clear();
		var fill = {
			color : modalColor, alpha : modalAlpha
		}
		modalMC.lineStyle (0, 0x000000, 0);
		modalMC.beginFill (fill.color, fill.alpha);
		modalMC.lineTo (sW, 0);
		modalMC.lineTo (sW, sH);
		modalMC.lineTo (0, sH);
		modalMC.lineTo (0, 0);
		modalMC.endFill ();
		modalMC.onRollOver= function(){
			
		}
		modalMC.useHandCursor=false;
		modalMC._visible=false;
	}
	private function findLowestDepth(pMc)
	{
		var lowestDepth=0;
		var lastDepth=0;
		for(var xmc in pMc)
		{
			var xDepth=pMc[xmc].getDepth();
			//trace('timeline[xmc].getDepth(): ' +timeline[xmc] +' ' + timeline[xmc].getDepth())
			lowestDepth= (xDepth<lastDepth) ? xDepth: lastDepth;
			lastDepth=xDepth;		
		}
		lowestDepth=lowestDepth-2;
		//trace('lowestDepth: ' + lowestDepth);
		return lowestDepth;
	}
	private function makeMC (scope : MovieClip, mcName : String) : MovieClip
	{
		var newMC = scope.createEmptyMovieClip (mcName, - scope.getNextHighestDepth ());
		return newMC
	}
};
